; ================================================================================================
; Konverter von tpm2-Protokoll auf WS2801/WS2811/TM1804
; Konfigurationen
; ================================================================================================

; ================================================================================================
; Ports I/O setzen etc.
; ------------------------------------------------------------------------------------------------

		ldi		temp0, (1<<Pix_SDO)|(1<<Pix_SCO); Pixel-Ports auf Ausgang
		out		Pix_DDR, temp0

		sbi		SEDU_DDR, S_LED					; Status-LED auf Ausgang
		cbi		SEDU_PORT, S_LED				; Status-LED an

		in		temp0, DDRA						; Pullups an allen Eingngen an
		com		temp0
		out		PortA, temp0

		in		temp0, DDRB						; Pullups an allen Eingngen an
		com		temp0
		out		PortB, temp0

		in		temp0, DDRB						; Pullups an allen Eingngen an
		com		temp0
		out		PortB, temp0

		in		temp0, DDRB						; Pullups an allen Eingngen an
		com		temp0
		out		PortB, temp0

; ================================================================================================
; Stackpointer setzen
; ------------------------------------------------------------------------------------------------

		ldi 	temp0, HIGH(RAMEND)				; HIGH-Byte der obersten RAM-Adresse
		out 	SPH, temp0						; in den Stackpointer
		ldi 	temp0, LOW(RAMEND)				; LOW-Byte der obersten RAM-Adresse
		out 	SPL, temp0						; in den Stackpointer

; ================================================================================================
; USART0 konfigurieren fr USB-Empfang
; ------------------------------------------------------------------------------------------------

		ldi		temp0, USB_BAUD					; Standard-Baudrate holen
		sts		RX_BAUDRATE, temp0				; abspeichern
		rcall	_set_baudrate					; Baudrate einstellen

; ================================================================================================
; Timer 0 konfigurieren fr Receiver-Timeout
; ------------------------------------------------------------------------------------------------

		ldi     temp0, (1<<CS02)	   			; Normal Mode, Prescaler auf 256, Timer starten
		out		TCCR0B, temp0

		ldi     temp0, (1<<TOIE0)      			; TOIE0: Interrupt bei Timer0 Overflow
		sts     TIMSK0, temp0

; ================================================================================================
; Grundeinstellungen
; ------------------------------------------------------------------------------------------------

		clr		flags							; Flags lschen

		sei										; Interrupts aktivieren

; ================================================================================================
; Pixel auf Startfarbe setzen
; ------------------------------------------------------------------------------------------------

		ldi		YH, high(PIX_OUTBUFFER)			; Zeiger auf Position Daten im RAM
		ldi		YL, low(PIX_OUTBUFFER)

		ldi		XL, low(PIX_COUNT)				; Zahl der angesteuerten Pixel in X-Register
		ldi		XH, high(PIX_COUNT)

_fill_pixel_loop:

		ldi		temp0, START_R					; Startfarbe Rot setzen
		st		Y+, temp0
		ldi		temp0, START_G					; Startfarbe Grn setzen
		st		Y+, temp0
		ldi		temp0, START_B					; Startfarbe Blau setzen
		st		Y+, temp0

		sbiw	XH:XL, 1						; Pixel zhlen
		brne	_fill_pixel_loop				; Noch nicht durch, zum nchsten

		ldi		temp0, low(PIX_COUNT*3)			; Alle Pixel ausgeben
		sts		RX_FRAMESIZE_L, temp0
		ldi		temp0, high(PIX_COUNT*3)
		sts		RX_FRAMESIZE_H, temp0

		sbr		flags, (1<<FL_FRAME_RECEIVED)	; Alle durch, Flag setzen fr Ausgabe

; ================================================================================================

