; ================================================================================================
; Konverter von tpm2-Protokoll auf WS2801/WS2811/TM1804
; Definitionen Register, Konstanten, etc.
; ================================================================================================

; ================================================================================================
; Register definieren
; ------------------------------------------------------------------------------------------------

.def Mathe_L			= R0			; Fr mathematische Berechnungen
.def Mathe_H			= R1

.def SREG_Save			= R2			; Statusregister sichern (Nur ISR!)

.def temp0 				= R16			; Mehrzweck-Temp-Register	
.def temp1 				= R17
.def temp2 				= R18
.def temp3				= R19
.def temp4				= R20

.def itemp0				= R21			; Mehrzweck-Temp-Register fr ISRs
.def itemp1				= R22
.def itemp2				= R23


.def rx_state			= R24			; (>15) Empfnger-Status
.def rx_timeout			= R8			; Zhler fr Timeout fehlender Empfang

.def temp_R				= R4			; fr Farbberechnungen
.def temp_G				= R5
.def temp_B				= R6

.def flags				= R25			; Div. Flags

; ================================================================================================
; Konstanten/Aliase definieren
; ------------------------------------------------------------------------------------------------

.equ XTAL				= 20000000		; Prozessortakt 20 MHz

.equ SEDU_PORT			= PortD			; Port fr SEDU intern
.equ SEDU_PIN			= PinD
.equ SEDU_DDR			= DDRD

.equ S_LED				= 5				; Status-LED

.equ FL_FRAME_RECEIVED	= 0				; Flag fr Frame empfangen
.equ FL_FRAME_TYPE		= 1				; Flag fr Frametyp: 0 = Daten, 1 = Befehl
.equ FL_STANDALONE		= 2				; Flag fr Standalone-Modus

.equ _Bootloader_Start	= 0x7C00		; Startadresse Bootloader im Flash
.equ BOOTSTRING_LENGHT	= 8				; Lnge Startcode fr Bootloader

; ================================================================================================
; RAM-Bereiche definieren
; ------------------------------------------------------------------------------------------------

.DSEG

RX_STOREPOINTER_H:		.byte 1			; Zeiger fr Daten Speichern
RX_STOREPOINTER_L:		.byte 1
RX_FRAMECOUNT_H:		.byte 1			; Zhler empfangene Bytes
RX_FRAMECOUNT_L:		.byte 1
RX_FRAMESIZE_H:			.byte 1			; Framegre
RX_FRAMESIZE_L:			.byte 1
RX_STARTADRESS_H:		.byte 1			; Startadresse Empfang
RX_STARTADRESS_L:		.byte 1
RX_STOPADRESS_H:		.byte 1			; Stop-Adresse Empfang
RX_STOPADRESS_L:		.byte 1
RX_BAUDRATE:			.byte 1			; Baudrate (0 = 250k, 1 = 500k, 2 = 1,25M)
RX_FE_COUNT:			.byte 1			; gezhlte Frame Errors

; ------------------------------------------------------------------------------------------------

PIX_OUTBUFFER:										; RAM-Puffer fr WS2801-Ausgabedaten

RX_BUFFER:				.byte DATA_FRAMESIZE_MAX	; RAM-Bereich fr empfangene Daten

; ================================================================================================
