; ================================================================================================
; Konverter von tpm2-Protokoll auf WS2801/WS2811/TM1804
; Baudrate setzen
; ================================================================================================

.equ UBRR_VAL_250 =((XTAL+250000*8)/(250000*16)-1) 	; UBBR fr 250 k

.equ UBRR_VAL_500 = ((XTAL+500000*4)/(500000*8)-1) 	; UBBR fr 500 k

.equ UBRR_VAL_1250 = 0						 	; UBBR fr 1,25 M bei 20 MHz

; ================================================================================================
; USART0 Baudrate setzen
; ------------------------------------------------------------------------------------------------

_set_baudrate:

		push	temp0
		push	temp1

		lds		temp0, RX_BAUDRATE				; Baudrate holen (0 = 250k, 1 = 500k, 2 = 1,25M)

		clr		temp1

		cpi		temp0, 1						; 500k eingestellt?
		brne	_sbr_no_double					; nein, weiter

		ldi		temp1, (1<<U2X0)				; ja, Double Speed fr 500 kBaud

_sbr_no_double:

		sts		UCSR0A, temp1			 		; DS-Flag setzen/lschen

		cpi		temp0, 1						; 500 k eingestellt?
		brne	_sbr_no_500						; nein, weiter
		ldi		temp0, UBRR_VAL_500				; ja, 500 einstellen
		rjmp	_sbr_set_ubbr

_sbr_no_500:

		cpi		temp0, 2						; 1,25 M eingestellt?
		brne	_sbr_no_1250					; nein, weiter
		ldi		temp0, UBRR_VAL_1250			; ja, 1,25 M einstellen
		rjmp	_sbr_set_ubbr

_sbr_no_1250:

		ldi		temp0, UBRR_VAL_250				; bleibt noch 250k

_sbr_set_ubbr:

    	sts 	UBRR0L, temp0					; Usart auf Baudrate setzen
    	clr 	temp0
    	sts 	UBRR0H, temp0

    	ldi 	temp0, (3<<UCSZ00)				; 8 Datenbits, 1 Stoppbit
    	sts 	UCSR0C, temp0			

		ldi		temp0, (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0) ; Rx, Tx, RxComplInt. enable
		sts		UCSR0B, temp0

		clr		rx_state						; Start-Status: auf Blockstart warten
		clr		rx_timeout						; Timeout zurcksetzen
		
		sts		RX_FE_COUNT, rx_timeout			; gezhlte FE zurck setzen
			
		pop		temp1
		pop		temp0

		ret

; ================================================================================================

