; ************************************************************************************************
; * Umsetzung von tpm2-Protokoll auf WS2801/WS2811/TM1804									 	 *
; *																								 *
; *	fr SEDU-Board v 2.0																		 *
; *																								 *
; *	by Pesi	- Version 1.0 - 20.02.2012															 *
; ************************************************************************************************

.include "m644Pdef.inc"							; verwendeter C: Mega644p

.include "Settings.inc"							; Benutzerdefinierte Einstellungen

.include "Definitions.inc"						; Definitionen Register, Konstanten etc.

.CSEG

.include "Interrupts.inc"						; IRQ-Vektor-Tabelle

; ================================================================================================
; Subroutinen
; ------------------------------------------------------------------------------------------------

.include "ISR_Byte_Received_USB.inc"			; Empfangsroutine tpm2 ber USB-Port

.include "Timer0OVF.inc"						; Timerroutine fr PWM, Zeitbasis, etc.

.include "Data_Shiftout.inc"					; Bitbang-Ausgaberoutine fr WS2801/TM1804

.include "Set_Baudrate.inc"						; Baudrate setzen

.include "Standalone.inc"						; Standalone-Programm

.include "Wait.inc"								; Warteschleifen

; ================================================================================================

_reset:

.include "Configuration.inc"					; Ports setzen, Timer konfigurieren etc.

; ================================================================================================
; Hauptschleife
; ------------------------------------------------------------------------------------------------

_main:

		sbrs	flags, FL_FRAME_RECEIVED		; Frame empfangen..?
		rjmp	_check_standalone				; nein, weiter

		cbr		flags, (1<<FL_FRAME_RECEIVED)	; ja, Flag wieder lschen
		rcall	_data_shiftout					; Frame ausgeben

		rjmp	_main							; von vorne

_check_standalone:

		sbrs	Flags, FL_STANDALONE			; Standalone-Programm aktiv?
		rjmp	_main							; nein, weiter

		rcall	_standalone						; ja, Standalone-Programm ausfhren

		rjmp	_main							; von vorne

; ================================================================================================
; Daten im Flash und EEPROM
; ------------------------------------------------------------------------------------------------

 Bootstring:

.db		"seduboot"								; Startcode fr Bootloader

; ================================================================================================
